<?php

namespace AppBundle\Repository;

use Doctrine\ORM\Query\ResultSetMapping;
use Symfony\Component\HttpFoundation\Session\Session;

/**
 * TEtudiantRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TEtudiantRepository extends \Doctrine\ORM\EntityRepository {
    
    /*SELECT * from t_inscription ins
inner join t_admission adm on ins.t_admission_id = adm.id 
inner join t_preinscription pre on adm.t_preinscription_id = pre.id
inner join t_etudiant etu on pre.t_etudiant_id = etu.id
where etu.id = '10526'*/
    
    /*ann.validationAcademique='non'*/
     public function GetInsCriptionActiveAnnee($Id) {
        $query = $this->getEntityManager()
                ->createQuery(
                        "SELECT ins   FROM AppBundle:TInscription ins
                                 JOIN ins.annee ann
                                 JOIN ins.admission adm
                                 JOIN adm.preinscription pre
                                 JOIN pre.etudiant etu
                                 WHERE ann.validationAcademique='non' and etu.id = :id"
                                 
                )->setParameter('id', $Id)
                ->setMaxResults(1)
                
                ;
        
       // var_dump($query->getSQL());
        try {
            return $query->getSingleResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }
    
    
    
    
    


    public function GetIdAdmissionByIdEtudiant($Id) {
        $query = $this->getEntityManager()
                ->createQuery(
                        'SELECT ins   FROM AppBundle:TInscription ins
                                 JOIN ins.admission adm
                                 JOIN adm.preinscription pre
                                 JOIN pre.etudiant etu
                                 WHERE etu.id = :id'
                )->setParameter('id', $Id)
                ->setMaxResults(1);
        try {
            return $query->getSingleResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }

    public function GetModuleByIdSemestres($t_inscription_id, $ac_annee_id, $ac_semestre_id) {
        $query = $this->getEntityManager()
                ->createQuery(
                        'SELECT mdl   FROM AppBundle:ExModules mdl
                                 JOIN mdl.semestre sem
                                 JOIN sem.promotion prm
                                 JOIN prm.inscription  ins
                                 JOIN ins.annee ann
                                 JOIN ins.promotion prm
                                 JOIN ann.mnote mnot
                                 JOIN ins.mnote mnot
                                 
                                 
                                 
                                 WHERE mnt.inscription = :t_inscription_id and mnt.annee = :ac_annee_id  and sem.id = :ac_semestre_id'
                )->setParameter('t_inscription_id', $t_inscription_id)
                ->setParameter('ac_annee_id', $ac_annee_id)
                ->setParameter('ac_semestre_id', $ac_semestre_id)
        ;
        try {
            return $query->getSQL();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }

    public function GetEtudiantAnneesByCodeAdmission($Id) {
        $query = $this->getEntityManager()
                        ->createQuery(
                                'SELECT ann  FROM AppBundle:AcAnnee ann
                                 JOIN ann.inscriptions ins
                                 WHERE ins.admission = :id'
                        )->setParameter('id', $Id);
        try {
            return $query->getResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }

    public function GetNotesBySemestreAndEtudiant($semestre_id) {

        $session = new Session();

//        echo $session->get('id_annee')."<br/>"; 
//        echo $session->get('id_inscription'); 
//        
//        die();


        $query = $this->getEntityManager()
                ->createQuery(
                        'SELECT ex    FROM AppBundle:ExMnotes ex
                                 JOIN ex.inscription ins
                                 JOIN ex.module mdl 
                                 JOIN mdl.semestre sem 
                                 
                                 WHERE sem.id = :semestre_id  and ex.inscription = :inscription_id and ex.annee = :annee_id'
                )->setParameter('semestre_id', $semestre_id)
                ->setParameter('annee_id', $session->get('id_annee'))
                ->setParameter('inscription_id', $session->get('id_inscription'));
        
       // var_dump($query->getResult()); die();
        try {
            return $query->getResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }
    
    
    
    
        public function GetEprevesNote() {

      $session = new Session();
      $query = $this->getEntityManager()
                ->createQuery(
                        'SELECT no,ins, prm    FROM AppBundle:ExGnotes no
                                 JOIN no.inscription ins
                                 JOIN ins.promotion prm 
                                 JOIN no.epreuve epr 
                                 
                                 WHERE  no.inscription = :inscription_id'
                )
                ->setParameter('inscription_id', $session->get('id_inscription'));
        
        //var_dump($query->getResult()); die();
        try {
            return $query->getResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }
    

    public function createAlphabeticalQueryBuilder() {
        return $this->createQueryBuilder('ac_annee')
                        ->orderBy('ac_annee.designation', 'ASC');
    }

    
  
    public function GetMoisByCodeSemestreOld($code_annee , $code_promotion , $code_semestre) {
        $query = $this->getEntityManager()
                        ->createQuery('SELECT prog.idAnnee , prog.idPromotion , prog.idSemestre ,  year (emp.start) as annee , month (emp.start) as mois   FROM AppBundle:PlEmptime emp
                                 JOIN emp.programmation prog
                                 WHERE prog.idAnnee = :code_annee
                                 and prog.idPromotion = :code_promotion
                                 and prog.idSemestre = :code_semestre
                                 group by annee , mois , prog.idAnnee , prog.idPromotion , prog.idSemestre '
                        )->setParameter('code_annee', $code_annee)
                         ->setParameter('code_promotion', $code_promotion)
                         ->setParameter('code_semestre', $code_semestre)
                ;
        try {
            return $query->getArrayResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }
    
    
        
    public function GetMoisByCodeSemestre($code_annee , $code_promotion , $code_semestre) {
        $query = $this->getEntityManager()
                        ->createQuery('SELECT abs.idAnnee , abs.idPromotion , abs.idSemestre ,  abs.annee , abs.mois   FROM AppBundle:XseanceAbsencesSyn abs
                                 WHERE abs.idAnnee = :code_annee
                                 and abs.idPromotion = :code_promotion
                                 and abs.idSemestre = :code_semestre
                                 group by abs.idAnnee , abs.idPromotion , abs.idSemestre ,  abs.annee , abs.mois '
                        )->setParameter('code_annee', $code_annee)
                         ->setParameter('code_promotion', $code_promotion)
                         ->setParameter('code_semestre', $code_semestre)
                ;
        try {
            return $query->getArrayResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }
    
    
    
//   SELECT  abs.ID_Admission , abs.categorie , emp.semaine , count(abs.categorie)   FROM `xseance_absences` abs inner join pl_emptime emp on emp.id = abs.ID_Seance  where abs.ID_Admission = 'ADM-FDA_FDA00001580'
//group by abs.ID_Admission , abs.categorie , emp.semaine having  emp.semaine = 10 
      
    public function GetAbscenceOld($mois , $code_annee , $code_promotion , $code_semestre, $code_admission) {
        $query = $this->getEntityManager()
                        ->createQuery('SELECT abs.idAdmission  ,abs.categorie  , emp.semaine  ,  prog.idAnnee , prog.idPromotion , prog.idSemestre ,  month (emp.start) as mois  , year (emp.start) as annee ,  count(abs.categorie) as total  FROM AppBundle:XseanceAbsences abs
                                 JOIN abs.emploi emp
                                 JOIN emp.programmation prog
                                 WHERE prog.idAnnee = :code_annee
                                 and prog.idPromotion = :code_promotion
                                 and prog.idSemestre = :code_semestre
                                 and abs.idAdmission = :code_admission
                                 and month (emp.start) = :m
                                 group by abs.idAdmission  ,abs.categorie  , emp.semaine  ,  prog.idAnnee , prog.idPromotion , prog.idSemestre , mois , annee
                                 order by month (emp.start) , emp.semaine ,abs.categorie asc  '
                                 
                        )->setParameter('code_annee', $code_annee)
                         ->setParameter('code_promotion', $code_promotion)
                         ->setParameter('code_semestre', $code_semestre)
                         ->setParameter('code_admission', $code_admission)
                         ->setParameter('m', $mois)
                ;
        try {
            return $query->getResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }
    
    
    
    
      public function GetAbscence($mois , $code_annee , $code_promotion , $code_semestre, $code_admission) {
        $query = $this->getEntityManager()
                        ->createQuery('SELECT abs.idAdmission  ,abs.categorie  , abs.semaine  ,  abs.idAnnee , abs.idPromotion , abs.idSemestre ,  abs.mois  , abs.annee ,   abs.total  FROM AppBundle:XseanceAbsencesSyn abs
                                 
                                 WHERE abs.idAnnee = :code_annee
                                 and abs.idPromotion = :code_promotion
                                 and abs.idSemestre = :code_semestre
                                 and abs.idAdmission = :code_admission
                                 and abs.mois = :m
                                 group by abs.idAdmission  ,abs.categorie  , abs.semaine  ,  abs.idAnnee , abs.idPromotion , abs.idSemestre ,  abs.mois  , abs.annee , abs.total
                                 order by abs.annee , abs.semaine ,abs.categorie asc  '
                                 
                        )->setParameter('code_annee', $code_annee)
                         ->setParameter('code_promotion', $code_promotion)
                         ->setParameter('code_semestre', $code_semestre)
                         ->setParameter('code_admission', $code_admission)
                         ->setParameter('m', $mois)
                ;
        try {
            return $query->getResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }
    
    
//    SELECT prog.id_annee , prog.id_promotion , prog.id_semestre , emp.semaine ,   year (emp.start) as annee    , month (emp.start) as mois FROM pl_emptime emp
//inner join pr_programmation prog on prog.code = emp.code_prog
//where prog.id_annee = 'ANN0000000100' and prog.id_promotion = 'PRM0000008' and prog.id_semestre = 'SEM00000118' and month (emp.start) = 3
//group by prog.id_annee , prog.id_promotion , prog.id_semestre , emp.semaine ,   year (emp.start)   , month (emp.start)
    
       public function GetSemaine($mois ,  $code_annee , $code_promotion , $code_semestre) {
        $query = $this->getEntityManager()
                        ->createQuery('SELECT prog.idAnnee , prog.idPromotion , prog.idSemestre ,emp.semaine ,   year (emp.start) as annee , month (emp.start) as mois    FROM AppBundle:PlEmptime emp
                                 JOIN emp.programmation prog
                                 WHERE prog.idAnnee = :code_annee
                                 and prog.idPromotion = :code_promotion
                                 and prog.idSemestre = :code_semestre
                                 and month (emp.start)  = :m
                                 group by  prog.idAnnee , prog.idPromotion , prog.idSemestre , emp.semaine,  annee , mois '
                        )->setParameter('code_annee', $code_annee)
                         ->setParameter('code_promotion', $code_promotion)
                         ->setParameter('code_semestre', $code_semestre)
                         ->setParameter('m', $mois)
                ;
        try {
            return $query->getResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }
    
    
    
}
